/*
 *    VisNow
 *    Copyright (C) 2006-2019 University of Warsaw, ICM
 *    Copyright (C) 2020 onward visnow.org
 *    All rights reserved. 
 * 
 *  DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
 *
 *  This code is free software; you can redistribute it and/or modify it
 *  under the terms of the GNU General Public License version 3, 
 *  or (at your option) any later version, as published by the Free Software Foundation.  
 *  The authors designate this particular file as subject to the "Classpath" exception 
 *  as provided in the LICENSE file that accompanied this code.
 *
 *  This code is distributed in the hope that it will be useful, but WITHOUT
 *  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 *  version 3 for more details (a copy is included in the LICENSE file that
 *  accompanied this code).
 *
 *  You should have received a copy of the GNU General Public License version 3
 *  along with this work; if not, see http://www.gnu.org/licenses/gpl-3.0.txt 
 *
 *  Please contact visnow.org or visit www.visnow.org if you need additional information or
 *  have any questions.
 *
 */

package org.visnow.vn.lib.basic.writers.ImageWriter;

import java.io.File;
import javax.swing.JFileChooser;
import javax.swing.filechooser.FileNameExtensionFilter;
import org.visnow.vn.engine.core.ParameterProxy;
import org.visnow.vn.engine.core.Parameters;
import org.visnow.vn.system.main.VisNow;
import org.visnow.vn.system.swing.filechooser.VNFileChooser;
import static org.visnow.vn.lib.basic.writers.ImageWriter.ImageWriterShared.*;

public class ImageWriterGUI extends javax.swing.JPanel
{

    private String lastPath = null;
    private Parameters parameters;

    /**
     * Creates new form EmptyVisnowModuleGUI
     */
    public ImageWriterGUI()
    {
        initComponents();
        FileNameExtensionFilter imageFilter = new FileNameExtensionFilter("Image files", "jpg", "jpeg", "JPG", "JPEG", "gif", "GIF", "png", "PNG", "tif", "TIF", "tiff", "TIFF", "bmp", "BMP");
        fileChooser.setFileFilter(imageFilter);

    }

    void setParameters(Parameters parameters)
    {
        this.parameters = parameters;
    }

    protected void updateGUI(final ParameterProxy p)
    {

        if (parameters == null) {
            flipICB.setEnabled(false);
            flipJCB.setEnabled(false);
            flipKCB.setEnabled(false);
            sliceIRB.setEnabled(false);
            sliceJRB.setEnabled(false);
            sliceKRB.setEnabled(false);
            formatCB.setEnabled(false);
            writeButton.setEnabled(false);
            return;
        }

        flipICB.setEnabled(true);
        flipICB.setSelected(parameters.get(FLIP_I));
        sliceIRB.setEnabled(false);
        sliceJRB.setEnabled(false);
        sliceKRB.setEnabled(false);
        slicePanel.setEnabled(false);
        if (parameters.get(META_FIELD_DIMENSION_LENGTH) > 1) {
            flipJCB.setEnabled(true);
            flipJCB.setSelected(parameters.get(FLIP_J));
        } else {
            flipJCB.setEnabled(false);
            flipJCB.setSelected(false);
        }
        if (parameters.get(META_FIELD_DIMENSION_LENGTH) > 2) {
            flipKCB.setEnabled(true);
            flipKCB.setSelected(parameters.get(FLIP_K));
            slicePanel.setEnabled(true);
            sliceIRB.setEnabled(true);
            sliceJRB.setEnabled(true);
            sliceKRB.setEnabled(true);
            switch (parameters.get(SLICE_AXIS)) {
                case 0:
                    sliceIRB.setSelected(true);
                    break;
                case 1:
                    sliceJRB.setSelected(true);
                    break;
                default:
                    sliceKRB.setSelected(true);
            }
        } else {
            flipKCB.setEnabled(false);
            flipKCB.setSelected(false);
        }
        formatCB.setEnabled(true);
        formatCB.setSelectedItem(parameters.get(FORMAT));
        writeButton.setEnabled(true);
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents()
    {
        java.awt.GridBagConstraints gridBagConstraints;

        fileChooser = new javax.swing.JFileChooser();
        buttonGroup1 = new javax.swing.ButtonGroup();
        jPanel3 = new javax.swing.JPanel();
        flipICB = new javax.swing.JCheckBox();
        flipJCB = new javax.swing.JCheckBox();
        flipKCB = new javax.swing.JCheckBox();
        jPanel4 = new javax.swing.JPanel();
        jPanel1 = new javax.swing.JPanel();
        formatCB = new javax.swing.JComboBox<>();
        writeButton = new javax.swing.JButton();
        jPanel2 = new javax.swing.JPanel();
        slicePanel = new javax.swing.JPanel();
        sliceJRB = new javax.swing.JRadioButton();
        sliceKRB = new javax.swing.JRadioButton();
        sliceIRB = new javax.swing.JRadioButton();

        setMinimumSize(new java.awt.Dimension(200, 500));
        setPreferredSize(new java.awt.Dimension(200, 500));
        setLayout(new java.awt.GridBagLayout());

        java.util.ResourceBundle bundle = java.util.ResourceBundle.getBundle("org/visnow/vn/lib/basic/writers/ImageWriter/Bundle"); // NOI18N
        jPanel3.setBorder(javax.swing.BorderFactory.createTitledBorder(bundle.getString("ImageWriterGUI.jPanel3.border.title"))); // NOI18N
        jPanel3.setLayout(new java.awt.GridBagLayout());

        flipICB.setText(bundle.getString("ImageWriterGUI.flipICB.text")); // NOI18N
        flipICB.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                flipICBActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_START;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        jPanel3.add(flipICB, gridBagConstraints);

        flipJCB.setText(bundle.getString("ImageWriterGUI.flipJCB.text")); // NOI18N
        flipJCB.setToolTipText(bundle.getString("ImageWriterGUI.flipJCB.toolTipText")); // NOI18N
        flipJCB.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                flipJCBActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_START;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        jPanel3.add(flipJCB, gridBagConstraints);

        flipKCB.setText(bundle.getString("ImageWriterGUI.flipKCB.text")); // NOI18N
        flipKCB.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                flipKCBActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_START;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        jPanel3.add(flipKCB, gridBagConstraints);

        javax.swing.GroupLayout jPanel4Layout = new javax.swing.GroupLayout(jPanel4);
        jPanel4.setLayout(jPanel4Layout);
        jPanel4Layout.setHorizontalGroup(
            jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 0, Short.MAX_VALUE)
        );
        jPanel4Layout.setVerticalGroup(
            jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 0, Short.MAX_VALUE)
        );

        jPanel3.add(jPanel4, new java.awt.GridBagConstraints());

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_START;
        gridBagConstraints.weightx = 1.0;
        add(jPanel3, gridBagConstraints);
        jPanel3.getAccessibleContext().setAccessibleName(bundle.getString("ImageWriterGUI.jPanel3.AccessibleContext.accessibleName")); // NOI18N

        jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder(bundle.getString("ImageWriterGUI.jPanel1.border.title"))); // NOI18N
        jPanel1.setLayout(new java.awt.BorderLayout());

        formatCB.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "JPEG", "PNG", "BMP", "GIF", "Animated GIF", "TIFF", "3D TIFF" }));
        formatCB.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                formatCBActionPerformed(evt);
            }
        });
        jPanel1.add(formatCB, java.awt.BorderLayout.CENTER);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_START;
        gridBagConstraints.weightx = 1.0;
        add(jPanel1, gridBagConstraints);

        writeButton.setText(bundle.getString("ImageWriterGUI.writeButton.text")); // NOI18N
        writeButton.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                writeButtonActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        add(writeButton, gridBagConstraints);

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 0, Short.MAX_VALUE)
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 0, Short.MAX_VALUE)
        );

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_START;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        add(jPanel2, gridBagConstraints);

        slicePanel.setBorder(javax.swing.BorderFactory.createTitledBorder(bundle.getString("ImageWriterGUI.slicePanel.border.title"))); // NOI18N
        slicePanel.setLayout(new java.awt.GridBagLayout());

        buttonGroup1.add(sliceJRB);
        sliceJRB.setText(bundle.getString("ImageWriterGUI.sliceJRB.text")); // NOI18N
        sliceJRB.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                sliceJRBActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_START;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        slicePanel.add(sliceJRB, gridBagConstraints);

        buttonGroup1.add(sliceKRB);
        sliceKRB.setText(bundle.getString("ImageWriterGUI.sliceKRB.text")); // NOI18N
        sliceKRB.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                sliceKRBActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_START;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        slicePanel.add(sliceKRB, gridBagConstraints);

        buttonGroup1.add(sliceIRB);
        sliceIRB.setText(bundle.getString("ImageWriterGUI.sliceIRB.text")); // NOI18N
        sliceIRB.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                sliceIRBActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_START;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        slicePanel.add(sliceIRB, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(slicePanel, gridBagConstraints);
    }// </editor-fold>//GEN-END:initComponents

    private void writeButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_writeButtonActionPerformed
        if (lastPath == null) {
            fileChooser.setCurrentDirectory(new File(VisNow.get().getMainConfig().getLastDataPath(ImageWriter.class)));
        } else {
            fileChooser.setCurrentDirectory(new File(lastPath));
        }

        int returnVal = fileChooser.showSaveDialog(this);
        if (returnVal == JFileChooser.APPROVE_OPTION) {
            FileNameExtensionFilter ext;
            if (formatCB.getSelectedItem().equals("PNG")) {
                ext = new FileNameExtensionFilter("PNG images", "png", "PNG");
            } else if (formatCB.getSelectedItem().equals("JPEG")) {
                ext = new FileNameExtensionFilter("JPEG images", "jpg", "jpeg", "JPG", "JPEG");
            } else if (formatCB.getSelectedItem().equals("BMP")) {
                ext = new FileNameExtensionFilter("BMP images", "bmp", "BMP");
            } else if (formatCB.getSelectedItem().equals("GIF") || formatCB.getSelectedItem().equals("Animated GIF")) {
                ext = new FileNameExtensionFilter("GIF images", "gif", "GIF");
            } else if (formatCB.getSelectedItem().equals("TIFF") || formatCB.getSelectedItem().equals("3D TIFF")) {
                ext = new FileNameExtensionFilter("TIFF images", "tif", "TIF", "tiff", "TIFF");
            } else {
                ext = new FileNameExtensionFilter("Image files", "jpg", "jpeg", "JPG", "JPEG", "gif", "GIF", "png", "PNG", "tif", "TIF", "tiff", "TIFF", "bmp", "BMP");
            }

            String path = VNFileChooser.filenameWithExtenstionAddedIfNecessary(fileChooser.getSelectedFile(), ext);
            lastPath = path.substring(0, path.lastIndexOf(File.separator));
            parameters.setParameterActive(false);
            parameters.set(WRITE, true);
            parameters.setParameterActive(true);
            parameters.set(FILENAME, path);
        }
        
    }//GEN-LAST:event_writeButtonActionPerformed

    private void flipICBActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_flipICBActionPerformed
        parameters.setParameterActive(false);
        parameters.set(FLIP_I, flipICB.isSelected());
        parameters.setParameterActive(true);
    }//GEN-LAST:event_flipICBActionPerformed

    private void flipJCBActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_flipJCBActionPerformed
        parameters.setParameterActive(false);
        parameters.set(FLIP_J, flipJCB.isSelected());
        parameters.setParameterActive(true);
    }//GEN-LAST:event_flipJCBActionPerformed

    private void formatCBActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_formatCBActionPerformed
    {//GEN-HEADEREND:event_formatCBActionPerformed
        parameters.setParameterActive(false);
        parameters.set(FORMAT,(String)formatCB.getSelectedItem());
        parameters.setParameterActive(true);
    }//GEN-LAST:event_formatCBActionPerformed

    private void flipKCBActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_flipKCBActionPerformed
    {//GEN-HEADEREND:event_flipKCBActionPerformed
        parameters.setParameterActive(false);
        parameters.set(FLIP_K, flipJCB.isSelected());
        parameters.setParameterActive(true);
    }//GEN-LAST:event_flipKCBActionPerformed

    private void sliceJRBActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_sliceJRBActionPerformed
    {//GEN-HEADEREND:event_sliceJRBActionPerformed
        parameters.setParameterActive(false);
        parameters.set(SLICE_AXIS, 1);
        parameters.setParameterActive(true);
    }//GEN-LAST:event_sliceJRBActionPerformed

    private void sliceIRBActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_sliceIRBActionPerformed
    {//GEN-HEADEREND:event_sliceIRBActionPerformed
        parameters.setParameterActive(false);
        parameters.set(SLICE_AXIS, 0);
        parameters.setParameterActive(true);
    }//GEN-LAST:event_sliceIRBActionPerformed

    private void sliceKRBActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_sliceKRBActionPerformed
    {//GEN-HEADEREND:event_sliceKRBActionPerformed
        parameters.setParameterActive(false);
        parameters.set(SLICE_AXIS, 2);
        parameters.setParameterActive(true);
    }//GEN-LAST:event_sliceKRBActionPerformed

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.ButtonGroup buttonGroup1;
    private javax.swing.JFileChooser fileChooser;
    private javax.swing.JCheckBox flipICB;
    private javax.swing.JCheckBox flipJCB;
    private javax.swing.JCheckBox flipKCB;
    private javax.swing.JComboBox<String> formatCB;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JRadioButton sliceIRB;
    private javax.swing.JRadioButton sliceJRB;
    private javax.swing.JRadioButton sliceKRB;
    private javax.swing.JPanel slicePanel;
    private javax.swing.JButton writeButton;
    // End of variables declaration//GEN-END:variables

}
